com.io7m.jtensors.core.parameterized.vectors

## Class PVector4D<T>

- java.lang.Object
- - com.io7m.jtensors.core.parameterized.vectors.PVector4D<T>

- Type Parameters:
    `T` - A phantom type parameter
  All Implemented Interfaces:
    PVector4DType<T>, PVectorReadable2DType<T>, PVectorReadable3DType<T>, PVectorReadable4DType<T>, VectorReadable2DType, VectorReadable3DType, VectorReadable4DType, VectorComputationalType

      @Generated(value={"Immutables.generator","PVector4DType<T>"})
      public final class PVector4D<T>
      extends Object
      implements PVector4DType<T>

  The type of 4D `double`-typed vectors.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `PVector4D.Builder<T>` Builds instances of type `PVector4D`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <T> PVector4D.Builder<T>` | `builder()` Creates a builder for `PVector4D`.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `PVector4D` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `x`, `y`, `z`, `w`.
    `static <T> PVector4D<T>` | `of(double x, double y, double z, double w)` Construct a new immutable `PVector4D` instance.
    `String` | `toString()` Prints the immutable value `PVector4D` with attribute values.
    `double` | `w()`
    `double` | `x()`
    `double` | `y()`
    `double` | `z()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### x

          public double x()

      Specified by:
        `x` in interface `PVector4DType<T>`
      Specified by:
        `x` in interface `VectorReadable2DType`
      Returns:
        The value of the `x` attribute

    - #### y

          public double y()

      Specified by:
        `y` in interface `PVector4DType<T>`
      Specified by:
        `y` in interface `VectorReadable2DType`
      Returns:
        The value of the `y` attribute

    - #### z

          public double z()

      Specified by:
        `z` in interface `PVector4DType<T>`
      Specified by:
        `z` in interface `VectorReadable3DType`
      Returns:
        The value of the `z` attribute

    - #### w

          public double w()

      Specified by:
        `w` in interface `PVector4DType<T>`
      Specified by:
        `w` in interface `VectorReadable4DType`
      Returns:
        The value of the `w` attribute

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `PVector4D` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `x`, `y`, `z`, `w`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `PVector4D` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static <T> PVector4D<T> of(double x,
                                            double y,
                                            double z,
                                            double w)

      Construct a new immutable `PVector4D` instance.
      Parameters:
        `x` - The value for the `x` attribute
        `y` - The value for the `y` attribute
        `z` - The value for the `z` attribute
        `w` - The value for the `w` attribute
      Returns:
        An immutable PVector4D instance

    - #### builder

          public static <T> PVector4D.Builder<T> builder()

      Creates a builder for `PVector4D`.
      Type Parameters:
        `T` - generic parameter T
      Returns:
        A new PVector4D builder

Copyright © 2017 <code@io7m.com> http://io7m.com